


#include <stm32f10x.h>

#include "Platine.h"

#include "Utilitaires.h"
#include "SPI.h"
#include "Graphique.h"



#define PLATINE_LCD_RETROECLAIRAGE 6
#define PLATINE_LCD_LED 7



extern unsigned char g_EtatDuRetroeclairage;
extern unsigned char g_EtatLEDGraphique;
extern unsigned char g_BlocActuel;



unsigned char InitialiserModuleGraphique(void)
{
	GPIOA->BSRR = (1 << 1);	/* ~CS_MCP23S117 = 1 */



	EcrireRegistreExpanseur(AdresseModuleGraphique, 0x00, 0x00, 0x00);
	Delai(100);
	EcrireRegistreExpanseur(AdresseModuleGraphique, 0x12, 0x00, 0x00);


	
	ChangerEtatRetroeclairage(1);
	InitialiserAfficheurGraphique(1);
	InitialiserAfficheurGraphique(0);
	
	EffacerAfficheurGraphique(0);
	ChangerEtatLED(0);



	return 1;
}

unsigned char ChangerEtatLED(unsigned char Commande)
{
	unsigned char Etat = 0x00;
	
	Etat |= (g_EtatDuRetroeclairage | g_BlocActuel);

	Commande &= 0x01;

	Commande <<= PLATINE_LCD_LED;

	if(g_EtatLEDGraphique == Commande)
	{
		return 0;
	}

	EcrireRegistreExpanseur(AdresseModuleGraphique, 0x12, (Etat | Commande), 0x00);

	g_EtatLEDGraphique = Commande;

	return 1;
}
	
unsigned char ChangerEtatRetroeclairage(unsigned char Commande)
{
	unsigned char Etat = 0x00;

	Etat |= (g_EtatLEDGraphique | g_BlocActuel);

	Commande &= 0x01;

	Commande <<= PLATINE_LCD_RETROECLAIRAGE;

	if(g_EtatDuRetroeclairage == Commande)
	{
		return 0;
	}

	EcrireRegistreExpanseur(AdresseModuleGraphique, 0x12, (Etat | Commande), 0x00);

	g_EtatDuRetroeclairage = Commande;

	return 1;
}

/* Remettre les donnes  l'endroit, aprs les avoir rcupres, ou avant de les renvoyer aux broches  DB0    DB7  de l'afficheur graphique

Paramtre d'entre :

paquet - Donne  retourner.

Valeur de retour :

Donne fournie en entre, retourne.

*/
unsigned char Retourner(unsigned char Paquet)
{
	int k;

	unsigned char Collecteur[8] = {0};
	unsigned char Envers = 0;

	for(k = 0; k < 8; k++)
	{
		Collecteur[k] = ((Paquet >> k) & 0x01);
	}
	for(k = 0; k < 8; k++)
	{
		Envers |= (Collecteur[7 - k] << k);
	}
	return Envers;
}


